﻿' -----------------------------------------------------------------------------------------
'
' ABSdemoVB2008                                                     Ulrich Müller  24.05.09
'                                                                   Aspire  VB 2005 Express
' Funktionsmodell für eine ABS-Bremse
'    Basis : Assembly FishFace2005.DLL
'
' -----------------------------------------------------------------------------------------

Option Explicit On
Option Strict Off
Imports FishFace40
Imports System.Threading

Public Class ABSdemoVB2008
  Dim mKompressor As Out = Out.M1
  Dim mBremsscheibe As Out = Out.M2
  Dim oMinderdruck As Out = Out.O5
  Dim oBremszylinder As Out = Out.O6
  Dim mLichtschranke As Out = Out.M4
  Dim iMinderdruck As Inp = Inp.I6
  Dim iLichtschranke As Inp = Inp.I7
  Dim iBremstaster As Inp = Inp.I8

  Dim ft As New FishFace()
  Dim Drehen As Thread
  Dim Druck As Thread

  Private Sub Action()
    Drehen = New Thread(New ThreadStart(AddressOf DrehenRun))
    Druck = New Thread(New ThreadStart(AddressOf DruckRun))
    Drehen.IsBackground = True
    Druck.IsBackground = True
    Druck.Start()
    Drehen.Start()
    ft.SetMotor(mKompressor, Dir.On)
    ft.SetMotor(mBremsscheibe, Dir.On)
    ft.SetMotor(mLichtschranke, Dir.On)
    ft.Pause(1234)
    Do
      ft.WaitForInput(iBremstaster)
      ft.SetLamp(oBremszylinder, Dir.On)
      ft.WaitForInput(iBremstaster, False)
      ft.SetLamp(oBremszylinder, Dir.Off)
    Loop Until ft.Finish()
    Drehen.Join()
  End Sub
  Private Sub DruckRun()
    ft.SetLamp(oMinderdruck, Dir.On)
    ft.WaitForInput(iMinderdruck, False)
    ft.SetLamp(oMinderdruck, Dir.Off)
  End Sub
  Private Sub DrehenRun()
    Do While (Not ft.NotHalt)
      ft.Pause(300)
      If ft.GetInput(iBremstaster) Then
        If ft.GetCounter(iLichtschranke) > 0 Then
          ft.SetCounter(iLichtschranke, 0)
          ft.SetLamp(oBremszylinder, Dir.On)
        Else
          ft.SetLamp(oBremszylinder, Dir.Off)
        End If
      End If
    Loop
  End Sub

#Region "--- ProgramControl ---"
  Private Sub cmdAction_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
  Handles cmdAction.Click
    ' --- Open erste ROBO Interface an USB oder Intelligent Interface an COM ---
    '     während des Ablaufs von Action gesperrt
    Try
      If cboPortName.SelectedIndex = 0 Then
        ft.OpenInterface(IFTypen.ftROBO_first_USB, 0)
      Else
        ft.OpenInterface(IFTypen.ftIntelligent_IF, cboPortName.SelectedIndex, 5)
      End If
      cmdAction.Enabled = False
      cmdEnde.Text = "&HALT"
      lblStatus.Text = "--- Bei der Arbeit ---"

      Action()          ' --- Nutz-Routine für die Anwendung

      ft.ClearMotors()
    Catch ex As FishFaceException
      MsgBox(ex.Message)
    Finally
      ft.CloseInterface()
      cmdAction.Enabled = True
      cmdEnde.Text = "&ENDE"
      lblStatus.Text = "--- Auf ein Neues ---"
      cmdEnde.Focus()
    End Try

  End Sub

  Private Sub cmdEnde_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdEnde.Click
    ' --- Programmende nur, wenn Action nicht läuft ---
    If cmdEnde.Text = "&HALT" Then ft.NotHalt = True Else Me.Close()
  End Sub

  Private Sub frmLoad(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    ' --- Default erstes ROBO Interface an USB ---
    cboPortName.SelectedIndex = 0
  End Sub

  Private Sub frmClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
    ' --- Wenn Action läuft, wird ein Programmabbruch über (x) unterbunden ---
    If cmdEnde.Text = "&HALT" Then e.Cancel = True
  End Sub

#End Region
End Class
